<template>
  <div class="menu-content-sized-container">
    <sub-main :contents="contents"> </sub-main>
  </div>
</template>

<script>
export default {
  head: {
    title: "Interfaces | THORChain.org",
    meta: [
        { property: "og:locale", content: "en_US" },
        { property: "og:type", content: "website" },
        { property: "og:title", content: "Interfaces | THORChain.org" },
        {
          property: "og:description",
          content:
            "THORChain aims to decentralize cryptocurrency liquidity via a network of public THORNodes and ecosystem products. Access to its native and cross-chain liquidity is open to any person, product or institution.",
        },
        { property: "og:url", content: process.env.baseUrl },
        { property: "og:site_name", content: "THORChain" },
        {
          property: "og:image",
          content: process.env.baseUrl + "/images/meta-interfaces.png",
        },
        { property: "og:image:width", content: "876" },
        { property: "og:image:heigh", content: "438" },
        { name: "twitter:creator", content: "@thorchain" },
        { name: "twitter:site", content: "@thorchain" },
        { name: "twitter:title", content: "Interfaces | THORChain.org" },
        {
          name: "twitter:description",
          content:
            "THORChain aims to decentralize cryptocurrency liquidity via a network of public THORNodes and ecosystem products. Access to its native and cross-chain liquidity is open to any person, product or institution.",
        },
        { name: "twitter:card", content: "summary_large_image" },
        {
          name: "twitter:image",
          content: process.env.baseUrl + "/images/meta-interfaces.png",
        },
      ],
  },
  async asyncData({app, $links}) {
    let interfaces = [
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "THORSwap",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Web App",
                linkProps: $links("interfaces_thorswap_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "TestNet Web App",
                linkProps: $links("interfaces_thorswap_testnet_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "StageNet Web App",
                linkProps: $links("interfaces_thorswap_stagenet_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Desktop App",
                linkProps: $links("interfaces_thorswap_desktop_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_thorswap_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Discord",
                linkProps: $links("interfaces_thorswap_discord"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Blog",
                linkProps: $links("interfaces_thorswap_blog"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/thorswap.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "ASGARDEX",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Desktop App",
                linkProps: $links("interfaces_asgardex_desktop_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_asgardex_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Discord",
                linkProps: $links("interfaces_asgardex_discord"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Github",
                linkProps: $links("interfaces_asgardex_github"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/asgardex.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#232A32",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "SKIP",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Web App",
                linkProps: $links("interfaces_skip_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "TestNet Web App",
                linkProps: $links("interfaces_skip_testnet_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_skip_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Telegram",
                linkProps: $links("interfaces_skip_telegram"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Discord",
                linkProps: $links("interfaces_skip_discord"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Github",
                linkProps: $links("interfaces_skip_github"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/skip.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "Brokkr",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Web App",
                linkProps: $links("interfaces_brokkr_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_brokkr_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Telegram",
                linkProps: $links("interfaces_brokkr_telegram"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/brokkr.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "ShapeShift",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Mobile App",
                linkProps: $links("interfaces_shapeshift_mobile_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Desktop Web App",
                linkProps: $links("interfaces_shapeshift_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_shapeshift_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Discord",
                linkProps: $links("interfaces_shapeshift_discord"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/shapeshift.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "THORWallet",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Website / Mobile App",
                linkProps: $links("interfaces_thorwallet_website"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Web App",
                linkProps: $links("interfaces_thorwallet_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Whitepaper",
                linkProps: $links("interfaces_thorwallet_whitepaper"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_thorwallet_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Telegram",
                linkProps: $links("interfaces_thorwallet_telegram"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Blog",
                linkProps: $links("interfaces_thorwallet_blog"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Github",
                linkProps: $links("interfaces_thorwallet_github"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/thorwallet.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "DeFiSpot",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Web App",
                linkProps: $links("interfaces_defispot_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_defispot_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Telegram",
                linkProps: $links("interfaces_defispot_telegram"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Discord",
                linkProps: $links("interfaces_defispot_discord"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/defispot.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "Rango Exchange",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Website",
                linkProps: $links("interfaces_rangoexchange_website"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_rangoexchange_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Telegram",
                linkProps: $links("interfaces_rangoexchange_telegram"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Blog",
                linkProps: $links("interfaces_rangoexchange_blo"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/rango.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
      {
        component: "halved",
        left: [
          {
            component: "text",
            title: "Ferz Wallet",
          },
          {
            component: "button",
            buttons: [
              {
                text: "Web App",
                linkProps: $links("interfaces_ferz_web_app"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Chrome Extension",
                linkProps: $links("interfaces_ferz_chrome_ext"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Twitter",
                linkProps: $links("interfaces_ferz_twitter"),
              },
            ],
          },
          {
            component: "button",
            buttons: [
              {
                text: "Telegram",
                linkProps: $links("interfaces_ferz_telegram"),
              },
            ],
          },
        ],
        right: [
          {
            component: "image",
            src: require("~/assets/images/interfaces/ferz.svg"),
            positionRight: "50%",
            positionTop: "50%",
            extraCSS: {
              background: "#000B12",
              objectFit: "none",
            },
          },
        ],
      },
    ];
    let scrolls = [
      { text: "THORSwap", id: "thorswap" },
      { text: "ASGARDEX", id: "asgardex" },
      { text: "SKIP", id: "skip" },
      { text: "Brokkr", id: "brokkr" },
      { text: "ShapeShift", id: "shapeshift" },
      { text: "THORWallet", id: "thorwallet" },
      { text: "DefiSpot", id: "defispot" },
      { text: "Rango Exchange", id: "rango" },
      { text: "Ferz Wallet", id: "ferz" },
    ]
    let shuffleWithScrolls = function(array, scrolls) {
      for (let i = array.length - 1; i > 0; i--) {
        let j = Math.floor(Math.random() * (i + 1)); // random index from 0 to i
        [array[i], array[j]] = [array[j], array[i]];
        [scrolls[i], scrolls[j]] = [scrolls[j], scrolls[i]]
      }
      return {array, scrolls};
    }
    let shuffledInterfaces = shuffleWithScrolls(interfaces, scrolls);
    return {
      contents: [
        {
          component: "header",
          settings: {
            title: "Interfaces",
            left: {
              text: "Compared",
              linkProps: $links("slash_interfaces"),
            },
            right: {
              text: "Links",
              linkProps: $links("slash_interfaces_links"),
            },
          },
        },
        {
          component: "halved",
          settings: {
            left: {
              title: "Access Liquidity",
              text: "The community has developed a variety of desktop and mobile interfaces so that you can interact with the THORChain protocol with ease.",
              scrolls: [...shuffledInterfaces.scrolls],
            },
            right: [...shuffledInterfaces.array],
          },
        },
      ]
    }
    // $set(contents[1].settings, 'right', shuffledInterfaces.array)
    // $set(contents[1].settings.left, 'scrolls', shuffledInterfaces.scrolls)
  },
  data() {
    return {
      contents: [],
    };
  },
};
</script>

<style>
</style>